Index: code/branches/physics/src/bullet/BulletSoftBody/btSoftBody.cpp
===================================================================
--- code/branches/physics/src/bullet/BulletSoftBody/btSoftBody.cpp	(revision 1971)
+++ code/branches/physics/src/bullet/BulletSoftBody/btSoftBody.cpp	(revision 1972)
@@ -1170,70 +1170,68 @@
 bool			btSoftBody::cutLink(int node0,int node1,btScalar position)
 {
-	bool			done=false;
-	int i,ni;
-	const btVector3	d=m_nodes[node0].m_x-m_nodes[node1].m_x;
-	const btVector3	x=Lerp(m_nodes[node0].m_x,m_nodes[node1].m_x,position);
-	const btVector3	v=Lerp(m_nodes[node0].m_v,m_nodes[node1].m_v,position);
-	const btScalar	m=1;
-	appendNode(x,m);
-	appendNode(x,m);
-	Node*			pa=&m_nodes[node0];
-	Node*			pb=&m_nodes[node1];
-	Node*			pn[2]={	&m_nodes[m_nodes.size()-2],
-		&m_nodes[m_nodes.size()-1]};
-	pn[0]->m_v=v;
-	pn[1]->m_v=v;
-	for(i=0,ni=m_links.size();i<ni;++i)
-	{
-		const int mtch=MatchEdge(m_links[i].m_n[0],m_links[i].m_n[1],pa,pb);
+bool			done=false;
+int i,ni;
+const btVector3	d=m_nodes[node0].m_x-m_nodes[node1].m_x;
+const btVector3	x=Lerp(m_nodes[node0].m_x,m_nodes[node1].m_x,position);
+const btVector3	v=Lerp(m_nodes[node0].m_v,m_nodes[node1].m_v,position);
+const btScalar	m=1;
+appendNode(x,m);
+appendNode(x,m);
+Node*			pa=&m_nodes[node0];
+Node*			pb=&m_nodes[node1];
+Node*			pn[2]={	&m_nodes[m_nodes.size()-2],
+						&m_nodes[m_nodes.size()-1]};
+pn[0]->m_v=v;
+pn[1]->m_v=v;
+for(i=0,ni=m_links.size();i<ni;++i)
+	{
+	const int mtch=MatchEdge(m_links[i].m_n[0],m_links[i].m_n[1],pa,pb);
+	if(mtch!=-1)
+		{
+		appendLink(i);
+		Link*	pft[]={&m_links[i],&m_links[m_links.size()-1]};
+		pft[0]->m_n[1]=pn[mtch];
+		pft[1]->m_n[0]=pn[1-mtch];
+		done=true;
+		}
+	}
+for(i=0,ni=m_faces.size();i<ni;++i)
+	{
+	for(int k=2,l=0;l<3;k=l++)
+		{
+		const int mtch=MatchEdge(m_faces[i].m_n[k],m_faces[i].m_n[l],pa,pb);
 		if(mtch!=-1)
-		{
-			appendLink(i);
-			Link*	pft[]={&m_links[i],&m_links[m_links.size()-1]};
-			pft[0]->m_n[1]=pn[mtch];
-			pft[1]->m_n[0]=pn[1-mtch];
-			done=true;
-		}
-	}
-	for(i=0,ni=m_faces.size();i<ni;++i)
-	{
-		for(int k=2,l=0;l<3;k=l++)
-		{
-			const int mtch=MatchEdge(m_faces[i].m_n[k],m_faces[i].m_n[l],pa,pb);
-			if(mtch!=-1)
-			{
-				appendFace(i);
-				Face*	pft[]={&m_faces[i],&m_faces[m_faces.size()-1]};
-				pft[0]->m_n[l]=pn[mtch];
-				pft[1]->m_n[k]=pn[1-mtch];
-				appendLink(pn[0],pft[0]->m_n[(l+1)%3],pft[0]->m_material,true);
-				appendLink(pn[1],pft[0]->m_n[(l+1)%3],pft[0]->m_material,true);
-			}
-		}
-	}
-	if(!done)
-	{
-		m_ndbvt.remove(pn[0]->m_leaf);
-		m_ndbvt.remove(pn[1]->m_leaf);
-		m_nodes.pop_back();
-		m_nodes.pop_back();
-	}
-	return(done);
-}
-
-//
-bool			btSoftBody::rayTest(const btVector3& rayFrom,
-									const btVector3& rayTo,
-									sRayCast& results)
-{
-	if(m_faces.size()&&m_fdbvt.empty()) 
-		initializeFaceTree();
-
-	results.body	=	this;
-	results.fraction = 1.f;
-	results.feature	=	eFeature::None;
-	results.index	=	-1;
-
-	return(rayTest(rayFrom,rayTo,results.fraction,results.feature,results.index,false)!=0);
+			{
+			appendFace(i);
+			Face*	pft[]={&m_faces[i],&m_faces[m_faces.size()-1]};
+			pft[0]->m_n[l]=pn[mtch];
+			pft[1]->m_n[k]=pn[1-mtch];
+			appendLink(pn[0],pft[0]->m_n[(l+1)%3],pft[0]->m_material,true);
+			appendLink(pn[1],pft[0]->m_n[(l+1)%3],pft[0]->m_material,true);
+			}
+		}
+	}
+if(!done)
+	{
+	m_ndbvt.remove(pn[0]->m_leaf);
+	m_ndbvt.remove(pn[1]->m_leaf);
+	m_nodes.pop_back();
+	m_nodes.pop_back();
+	}
+return(done);
+}
+
+//
+bool			btSoftBody::rayCast(const btVector3& org,
+									const btVector3& dir,
+									sRayCast& results,
+									btScalar maxtime)
+{
+if(m_faces.size()&&m_fdbvt.empty()) initializeFaceTree();
+results.body	=	this;
+results.time	=	maxtime;
+results.feature	=	eFeature::None;
+results.index	=	-1;
+return(rayCast(org,dir,results.time,results.feature,results.index,false)!=0);
 }
 
@@ -1241,24 +1239,24 @@
 void			btSoftBody::setSolver(eSolverPresets::_ preset)
 {
-	m_cfg.m_vsequence.clear();
-	m_cfg.m_psequence.clear();
-	m_cfg.m_dsequence.clear();
-	switch(preset)
+m_cfg.m_vsequence.clear();
+m_cfg.m_psequence.clear();
+m_cfg.m_dsequence.clear();
+switch(preset)
 	{
 	case	eSolverPresets::Positions:
-		m_cfg.m_psequence.push_back(ePSolver::Anchors);
-		m_cfg.m_psequence.push_back(ePSolver::RContacts);
-		m_cfg.m_psequence.push_back(ePSolver::SContacts);
-		m_cfg.m_psequence.push_back(ePSolver::Linear);	
-		break;	
+	m_cfg.m_psequence.push_back(ePSolver::Anchors);
+	m_cfg.m_psequence.push_back(ePSolver::RContacts);
+	m_cfg.m_psequence.push_back(ePSolver::SContacts);
+	m_cfg.m_psequence.push_back(ePSolver::Linear);	
+	break;	
 	case	eSolverPresets::Velocities:
-		m_cfg.m_vsequence.push_back(eVSolver::Linear);
-
-		m_cfg.m_psequence.push_back(ePSolver::Anchors);
-		m_cfg.m_psequence.push_back(ePSolver::RContacts);
-		m_cfg.m_psequence.push_back(ePSolver::SContacts);
-
-		m_cfg.m_dsequence.push_back(ePSolver::Linear);
-		break;
+	m_cfg.m_vsequence.push_back(eVSolver::Linear);
+	
+	m_cfg.m_psequence.push_back(ePSolver::Anchors);
+	m_cfg.m_psequence.push_back(ePSolver::RContacts);
+	m_cfg.m_psequence.push_back(ePSolver::SContacts);
+	
+	m_cfg.m_dsequence.push_back(ePSolver::Linear);
+	break;
 	}
 }
@@ -1276,9 +1274,9 @@
 		m_fdbvt.clear();
 		if(m_cfg.collisions&fCollision::VF_SS)
-		{
+			{
 			initializeFaceTree();			
-		}
-	}
-
+			}
+	}
+		
 	/* Prepare				*/ 
 	m_sst.sdt		=	dt*m_cfg.timescale;
@@ -1308,39 +1306,39 @@
 		Node&	n=m_nodes[i];
 		m_ndbvt.update(	n.m_leaf,
-			btDbvtVolume::FromCR(n.m_x,m_sst.radmrg),
-			n.m_v*m_sst.velmrg,
-			m_sst.updmrg);
+						btDbvtVolume::FromCR(n.m_x,m_sst.radmrg),
+						n.m_v*m_sst.velmrg,
+						m_sst.updmrg);
 	}
 	/* Faces				*/ 
 	if(!m_fdbvt.empty())
-	{
+		{
 		for(int i=0;i<m_faces.size();++i)
-		{
+			{
 			Face&			f=m_faces[i];
 			const btVector3	v=(	f.m_n[0]->m_v+
-				f.m_n[1]->m_v+
-				f.m_n[2]->m_v)/3;
+								f.m_n[1]->m_v+
+								f.m_n[2]->m_v)/3;
 			m_fdbvt.update(	f.m_leaf,
-				VolumeOf(f,m_sst.radmrg),
-				v*m_sst.velmrg,
-				m_sst.updmrg);
-		}
-	}
+							VolumeOf(f,m_sst.radmrg),
+							v*m_sst.velmrg,
+							m_sst.updmrg);
+			}
+		}
 	/* Pose					*/ 
 	updatePose();
 	/* Match				*/ 
 	if(m_pose.m_bframe&&(m_cfg.kMT>0))
-	{
+		{
 		const btMatrix3x3	posetrs=m_pose.m_rot;
 		for(int i=0,ni=m_nodes.size();i<ni;++i)
-		{
+			{
 			Node&	n=m_nodes[i];
 			if(n.m_im>0)
-			{
+				{
 				const btVector3	x=posetrs*m_pose.m_pos[i]+m_pose.m_com;
 				n.m_x=Lerp(n.m_x,x,m_cfg.kMT);
-			}
-		}
-	}
+				}
+			}
+		}
 	/* Clear contacts		*/ 
 	m_rcontacts.resize(0);
@@ -1355,92 +1353,92 @@
 void			btSoftBody::solveConstraints()
 {
-	/* Apply clusters		*/ 
-	applyClusters(false);
-	/* Prepare links		*/ 
-
-	int i,ni;
-
-	for(i=0,ni=m_links.size();i<ni;++i)
-	{
-		Link&	l=m_links[i];
-		l.m_c3		=	l.m_n[1]->m_q-l.m_n[0]->m_q;
-		l.m_c2		=	1/(l.m_c3.length2()*l.m_c0);
-	}
-	/* Prepare anchors		*/ 
-	for(i=0,ni=m_anchors.size();i<ni;++i)
-	{
-		Anchor&			a=m_anchors[i];
-		const btVector3	ra=a.m_body->getWorldTransform().getBasis()*a.m_local;
-		a.m_c0	=	ImpulseMatrix(	m_sst.sdt,
-			a.m_node->m_im,
-			a.m_body->getInvMass(),
-			a.m_body->getInvInertiaTensorWorld(),
-			ra);
-		a.m_c1	=	ra;
-		a.m_c2	=	m_sst.sdt*a.m_node->m_im;
-		a.m_body->activate();
-	}
-	/* Solve velocities		*/ 
-	if(m_cfg.viterations>0)
-	{
-		/* Solve			*/ 
-		for(int isolve=0;isolve<m_cfg.viterations;++isolve)
-		{
-			for(int iseq=0;iseq<m_cfg.m_vsequence.size();++iseq)
-			{
-				getSolver(m_cfg.m_vsequence[iseq])(this,1);
-			}
-		}
-		/* Update			*/ 
-		for(i=0,ni=m_nodes.size();i<ni;++i)
-		{
-			Node&	n=m_nodes[i];
-			n.m_x	=	n.m_q+n.m_v*m_sst.sdt;
-		}
-	}
-	/* Solve positions		*/ 
-	if(m_cfg.piterations>0)
-	{
-		for(int isolve=0;isolve<m_cfg.piterations;++isolve)
-		{
-			const btScalar ti=isolve/(btScalar)m_cfg.piterations;
-			for(int iseq=0;iseq<m_cfg.m_psequence.size();++iseq)
-			{
-				getSolver(m_cfg.m_psequence[iseq])(this,1,ti);
-			}
-		}
-		const btScalar	vc=m_sst.isdt*(1-m_cfg.kDP);
-		for(i=0,ni=m_nodes.size();i<ni;++i)
-		{
-			Node&	n=m_nodes[i];
-			n.m_v	=	(n.m_x-n.m_q)*vc;
-			n.m_f	=	btVector3(0,0,0);		
-		}
-	}
-	/* Solve drift			*/ 
-	if(m_cfg.diterations>0)
-	{
-		const btScalar	vcf=m_cfg.kVCF*m_sst.isdt;
-		for(i=0,ni=m_nodes.size();i<ni;++i)
-		{
-			Node&	n=m_nodes[i];
-			n.m_q	=	n.m_x;
-		}
-		for(int idrift=0;idrift<m_cfg.diterations;++idrift)
-		{
-			for(int iseq=0;iseq<m_cfg.m_dsequence.size();++iseq)
-			{
-				getSolver(m_cfg.m_dsequence[iseq])(this,1,0);
-			}
-		}
-		for(int i=0,ni=m_nodes.size();i<ni;++i)
-		{
-			Node&	n=m_nodes[i];
-			n.m_v	+=	(n.m_x-n.m_q)*vcf;
-		}
-	}
-	/* Apply clusters		*/ 
-	dampClusters();
-	applyClusters(true);
+/* Apply clusters		*/ 
+applyClusters(false);
+/* Prepare links		*/ 
+
+int i,ni;
+
+for(i=0,ni=m_links.size();i<ni;++i)
+	{
+	Link&	l=m_links[i];
+	l.m_c3		=	l.m_n[1]->m_q-l.m_n[0]->m_q;
+	l.m_c2		=	1/(l.m_c3.length2()*l.m_c0);
+	}
+/* Prepare anchors		*/ 
+for(i=0,ni=m_anchors.size();i<ni;++i)
+	{
+	Anchor&			a=m_anchors[i];
+	const btVector3	ra=a.m_body->getWorldTransform().getBasis()*a.m_local;
+	a.m_c0	=	ImpulseMatrix(	m_sst.sdt,
+								a.m_node->m_im,
+								a.m_body->getInvMass(),
+								a.m_body->getInvInertiaTensorWorld(),
+								ra);
+	a.m_c1	=	ra;
+	a.m_c2	=	m_sst.sdt*a.m_node->m_im;
+	a.m_body->activate();
+	}
+/* Solve velocities		*/ 
+if(m_cfg.viterations>0)
+	{
+	/* Solve			*/ 
+	for(int isolve=0;isolve<m_cfg.viterations;++isolve)
+		{
+		for(int iseq=0;iseq<m_cfg.m_vsequence.size();++iseq)
+			{
+			getSolver(m_cfg.m_vsequence[iseq])(this,1);
+			}
+		}
+	/* Update			*/ 
+	for(i=0,ni=m_nodes.size();i<ni;++i)
+		{
+		Node&	n=m_nodes[i];
+		n.m_x	=	n.m_q+n.m_v*m_sst.sdt;
+		}
+	}
+/* Solve positions		*/ 
+if(m_cfg.piterations>0)
+	{
+	for(int isolve=0;isolve<m_cfg.piterations;++isolve)
+		{
+		const btScalar ti=isolve/(btScalar)m_cfg.piterations;
+		for(int iseq=0;iseq<m_cfg.m_psequence.size();++iseq)
+			{
+			getSolver(m_cfg.m_psequence[iseq])(this,1,ti);
+			}
+		}
+	const btScalar	vc=m_sst.isdt*(1-m_cfg.kDP);
+	for(i=0,ni=m_nodes.size();i<ni;++i)
+		{
+		Node&	n=m_nodes[i];
+		n.m_v	=	(n.m_x-n.m_q)*vc;
+		n.m_f	=	btVector3(0,0,0);		
+		}
+	}
+/* Solve drift			*/ 
+if(m_cfg.diterations>0)
+	{
+	const btScalar	vcf=m_cfg.kVCF*m_sst.isdt;
+	for(i=0,ni=m_nodes.size();i<ni;++i)
+		{
+		Node&	n=m_nodes[i];
+		n.m_q	=	n.m_x;
+		}
+	for(int idrift=0;idrift<m_cfg.diterations;++idrift)
+		{
+		for(int iseq=0;iseq<m_cfg.m_dsequence.size();++iseq)
+			{
+			getSolver(m_cfg.m_dsequence[iseq])(this,1,0);
+			}
+		}
+	for(int i=0,ni=m_nodes.size();i<ni;++i)
+		{
+		Node&	n=m_nodes[i];
+		n.m_v	+=	(n.m_x-n.m_q)*vcf;
+		}
+	}
+/* Apply clusters		*/ 
+dampClusters();
+applyClusters(true);
 }
 
@@ -1448,9 +1446,9 @@
 void			btSoftBody::staticSolve(int iterations)
 {
-	for(int isolve=0;isolve<iterations;++isolve)
-	{
-		for(int iseq=0;iseq<m_cfg.m_psequence.size();++iseq)
-		{
-			getSolver(m_cfg.m_psequence[iseq])(this,1,0);
+for(int isolve=0;isolve<iterations;++isolve)
+	{
+	for(int iseq=0;iseq<m_cfg.m_psequence.size();++iseq)
+		{
+		getSolver(m_cfg.m_psequence[iseq])(this,1,0);
 		}
 	}
@@ -1460,5 +1458,5 @@
 void			btSoftBody::solveCommonConstraints(btSoftBody** /*bodies*/,int /*count*/,int /*iterations*/)
 {
-	/// placeholder
+/// placeholder
 }
 
@@ -1466,27 +1464,27 @@
 void			btSoftBody::solveClusters(const btAlignedObjectArray<btSoftBody*>& bodies)
 {
-	const int	nb=bodies.size();
-	int			iterations=0;
-	int i;
-
-	for(i=0;i<nb;++i)
-	{
-		iterations=btMax(iterations,bodies[i]->m_cfg.citerations);
-	}
-	for(i=0;i<nb;++i)
-	{
-		bodies[i]->prepareClusters(iterations);
-	}
-	for(i=0;i<iterations;++i)
-	{
-		const btScalar sor=1;
-		for(int j=0;j<nb;++j)
-		{
-			bodies[j]->solveClusters(sor);
-		}
-	}
-	for(i=0;i<nb;++i)
-	{
-		bodies[i]->cleanupClusters();
+const int	nb=bodies.size();
+int			iterations=0;
+int i;
+
+for(i=0;i<nb;++i)
+	{
+	iterations=btMax(iterations,bodies[i]->m_cfg.citerations);
+	}
+for(i=0;i<nb;++i)
+	{
+	bodies[i]->prepareClusters(iterations);
+	}
+for(i=0;i<iterations;++i)
+	{
+	const btScalar sor=1;
+	for(int j=0;j<nb;++j)
+		{
+		bodies[j]->solveClusters(sor);
+		}
+	}
+for(i=0;i<nb;++i)
+	{
+	bodies[i]->cleanupClusters();
 	}
 }
@@ -1500,52 +1498,46 @@
 
 //
-btSoftBody::RayFromToCaster::RayFromToCaster(const btVector3& rayFrom,const btVector3& rayTo,btScalar mxt)
-{
-	m_rayFrom = rayFrom;
-	m_rayNormalizedDirection = (rayTo-rayFrom);
-	m_rayTo = rayTo;
-	m_mint	=	mxt;
-	m_face	=	0;
-	m_tests	=	0;
-}
-
-//
-void				btSoftBody::RayFromToCaster::Process(const btDbvtNode* leaf)
-{
-	btSoftBody::Face&	f=*(btSoftBody::Face*)leaf->data;
-	const btScalar		t=rayFromToTriangle(	m_rayFrom,m_rayTo,m_rayNormalizedDirection,
-		f.m_n[0]->m_x,
-		f.m_n[1]->m_x,
-		f.m_n[2]->m_x,
-		m_mint);
-	if((t>0)&&(t<m_mint)) 
-	{ 
-		m_mint=t;m_face=&f; 
-	}
-	++m_tests;
-}
-
-//
-btScalar			btSoftBody::RayFromToCaster::rayFromToTriangle(	const btVector3& rayFrom,
-																   const btVector3& rayTo,
-																   const btVector3& rayNormalizedDirection,
-																   const btVector3& a,
-																   const btVector3& b,
-																   const btVector3& c,
-																   btScalar maxt)
+					btSoftBody::RayCaster::RayCaster(const btVector3& org,const btVector3& dir,btScalar mxt)
+{
+o		=	org;
+d		=	dir;
+mint	=	mxt;
+face	=	0;
+tests	=	0;
+}
+
+//
+void				btSoftBody::RayCaster::Process(const btDbvtNode* leaf)
+{
+btSoftBody::Face&	f=*(btSoftBody::Face*)leaf->data;
+const btScalar		t=rayTriangle(	o,d,
+									f.m_n[0]->m_x,
+									f.m_n[1]->m_x,
+									f.m_n[2]->m_x,
+									mint);
+if((t>0)&&(t<mint)) { mint=t;face=&f; }
+++tests;
+}
+
+//
+btScalar			btSoftBody::RayCaster::rayTriangle(	const btVector3& org,
+														const btVector3& dir,
+														const btVector3& a,
+														const btVector3& b,
+														const btVector3& c,
+														btScalar maxt)
 {
 	static const btScalar	ceps=-SIMD_EPSILON*10;
 	static const btScalar	teps=SIMD_EPSILON*10;
-
 	const btVector3			n=cross(b-a,c-a);
 	const btScalar			d=dot(a,n);
-	const btScalar			den=dot(rayNormalizedDirection,n);
+	const btScalar			den=dot(dir,n);
 	if(!btFuzzyZero(den))
 	{
-		const btScalar		num=dot(rayFrom,n)-d;
+		const btScalar		num=dot(org,n)-d;
 		const btScalar		t=-num/den;
 		if((t>teps)&&(t<maxt))
 		{
-			const btVector3	hit=rayFrom+rayNormalizedDirection*t;
+			const btVector3	hit=org+dir*t;
 			if(	(dot(n,cross(a-hit,b-hit))>ceps)	&&			
 				(dot(n,cross(b-hit,c-hit))>ceps)	&&
@@ -1569,7 +1561,7 @@
 	{
 		if(m_nodes[i].m_leaf)
-		{
+			{
 			m_nodes[i].m_leaf->data=*(void**)&i;
-		}
+			}
 	}
 	for(i=0,ni=m_links.size();i<ni;++i)
@@ -1584,19 +1576,19 @@
 		m_faces[i].m_n[2]=PTR2IDX(m_faces[i].m_n[2],base);
 		if(m_faces[i].m_leaf)
-		{
+			{
 			m_faces[i].m_leaf->data=*(void**)&i;
-		}
+			}
 	}
 	for(i=0,ni=m_anchors.size();i<ni;++i)
-	{
+		{
 		m_anchors[i].m_node=PTR2IDX(m_anchors[i].m_node,base);
-	}
+		}
 	for(i=0,ni=m_notes.size();i<ni;++i)
-	{
+		{
 		for(int j=0;j<m_notes[i].m_rank;++j)
-		{
+			{
 			m_notes[i].m_nodes[j]=PTR2IDX(m_notes[i].m_nodes[j],base);
-		}
-	}
+			}
+		}
 #undef	PTR2IDX
 }
@@ -1606,5 +1598,5 @@
 {
 #define	IDX2PTR(_p_,_b_)	map?(&(_b_)[map[(((char*)_p_)-(char*)0)]]):	\
-	(&(_b_)[(((char*)_p_)-(char*)0)])
+								(&(_b_)[(((char*)_p_)-(char*)0)])
 	btSoftBody::Node*	base=&m_nodes[0];
 	int i,ni;
@@ -1613,7 +1605,7 @@
 	{
 		if(m_nodes[i].m_leaf)
-		{
+			{
 			m_nodes[i].m_leaf->data=&m_nodes[i];
-		}
+			}
 	}
 	for(i=0,ni=m_links.size();i<ni;++i)
@@ -1628,66 +1620,61 @@
 		m_faces[i].m_n[2]=IDX2PTR(m_faces[i].m_n[2],base);
 		if(m_faces[i].m_leaf)
-		{
+			{
 			m_faces[i].m_leaf->data=&m_faces[i];
-		}
+			}
 	}
 	for(i=0,ni=m_anchors.size();i<ni;++i)
-	{
+		{
 		m_anchors[i].m_node=IDX2PTR(m_anchors[i].m_node,base);
-	}
+		}
 	for(i=0,ni=m_notes.size();i<ni;++i)
-	{
+		{
 		for(int j=0;j<m_notes[i].m_rank;++j)
-		{
+			{
 			m_notes[i].m_nodes[j]=IDX2PTR(m_notes[i].m_nodes[j],base);
-		}
-	}
+			}
+		}
 #undef	IDX2PTR
 }
 
 //
-int					btSoftBody::rayTest(const btVector3& rayFrom,const btVector3& rayTo,
+int					btSoftBody::rayCast(const btVector3& org,const btVector3& dir,
 										btScalar& mint,eFeature::_& feature,int& index,bool bcountonly) const
 {
 	int	cnt=0;
 	if(bcountonly||m_fdbvt.empty())
-	{/* Full search	*/ 
-		btVector3 dir = rayTo-rayFrom;
-		dir.normalize();
-
+		{/* Full search	*/ 
 		for(int i=0,ni=m_faces.size();i<ni;++i)
-		{
+			{
 			const btSoftBody::Face&	f=m_faces[i];
-
-			const btScalar			t=RayFromToCaster::rayFromToTriangle(	rayFrom,rayTo,dir,
-				f.m_n[0]->m_x,
-				f.m_n[1]->m_x,
-				f.m_n[2]->m_x,
-				mint);
+			const btScalar			t=RayCaster::rayTriangle(	org,dir,
+																f.m_n[0]->m_x,
+																f.m_n[1]->m_x,
+																f.m_n[2]->m_x,
+																mint);
 			if(t>0)
-			{
+				{
 				++cnt;
 				if(!bcountonly)
-				{
+					{
 					feature=btSoftBody::eFeature::Face;
 					index=i;
 					mint=t;
+					}
 				}
 			}
 		}
-	}
-	else
-	{/* Use dbvt	*/ 
-		RayFromToCaster	collider(rayFrom,rayTo,mint);
-
-		btDbvt::rayTest(m_fdbvt.m_root,rayFrom,rayTo,collider);
-		if(collider.m_face)
-		{
-			mint=collider.m_mint;
+		else
+		{/* Use dbvt	*/ 
+		RayCaster	collider(org,dir,mint);
+		btDbvt::collideRAY(m_fdbvt.m_root,org,dir,collider);
+		if(collider.face)
+			{
+			mint=collider.mint;
 			feature=btSoftBody::eFeature::Face;
-			index=(int)(collider.m_face-&m_faces[0]);
+			index=(int)(collider.face-&m_faces[0]);
 			cnt=1;
-		}
-	}
+			}
+		}
 	return(cnt);
 }
@@ -1696,9 +1683,9 @@
 void			btSoftBody::initializeFaceTree()
 {
-	m_fdbvt.clear();
-	for(int i=0;i<m_faces.size();++i)
-	{
-		Face&	f=m_faces[i];
-		f.m_leaf=m_fdbvt.insert(VolumeOf(f,0),&f);
+m_fdbvt.clear();
+for(int i=0;i<m_faces.size();++i)
+	{
+	Face&	f=m_faces[i];
+	f.m_leaf=m_fdbvt.insert(VolumeOf(f,0),&f);
 	}
 }
@@ -1707,20 +1694,20 @@
 btVector3		btSoftBody::evaluateCom() const
 {
-	btVector3	com(0,0,0);
-	if(m_pose.m_bframe)
-	{
-		for(int i=0,ni=m_nodes.size();i<ni;++i)
-		{
-			com+=m_nodes[i].m_x*m_pose.m_wgh[i];
+btVector3	com(0,0,0);
+if(m_pose.m_bframe)
+	{
+	for(int i=0,ni=m_nodes.size();i<ni;++i)
+		{
+		com+=m_nodes[i].m_x*m_pose.m_wgh[i];
 		}
 	}
 	return(com);
 }
-
+	
 //
 bool				btSoftBody::checkContact(	btRigidBody* prb,
-											 const btVector3& x,
-											 btScalar margin,
-											 btSoftBody::sCti& cti) const
+												const btVector3& x,
+												btScalar margin,
+												btSoftBody::sCti& cti) const
 {
 	btVector3			nrm;
@@ -1728,7 +1715,7 @@
 	const btTransform&	wtr=prb->getInterpolationWorldTransform();
 	btScalar			dst=m_worldInfo->m_sparsesdf.Evaluate(	wtr.invXform(x),
-		shp,
-		nrm,
-		margin);
+																shp,
+																nrm,
+																margin);
 	if(dst<0)
 	{
@@ -1736,5 +1723,5 @@
 		cti.m_normal	=	wtr.getBasis()*nrm;
 		cti.m_offset	=	-dot(	cti.m_normal,
-			x-cti.m_normal*dst);
+									x-cti.m_normal*dst);
 		return(true);
 	}
@@ -1756,5 +1743,5 @@
 		btSoftBody::Face&	f=m_faces[i];
 		const btVector3		n=cross(f.m_n[1]->m_x-f.m_n[0]->m_x,
-			f.m_n[2]->m_x-f.m_n[0]->m_x);
+									f.m_n[2]->m_x-f.m_n[0]->m_x);
 		f.m_normal=n.normalized();
 		f.m_n[0]->m_n+=n;
@@ -1774,26 +1761,26 @@
 {
 	if(m_ndbvt.m_root)
-	{
+		{
 		const btVector3&	mins=m_ndbvt.m_root->volume.Mins();
 		const btVector3&	maxs=m_ndbvt.m_root->volume.Maxs();
 		const btScalar		csm=getCollisionShape()->getMargin();
 		const btVector3		mrg=btVector3(	csm,
-			csm,
-			csm)*1; // ??? to investigate...
+											csm,
+											csm)*1; // ??? to investigate...
 		m_bounds[0]=mins-mrg;
 		m_bounds[1]=maxs+mrg;
-		if(0!=getBroadphaseHandle())
-		{					
-			m_worldInfo->m_broadphase->setAabb(	getBroadphaseHandle(),
-				m_bounds[0],
-				m_bounds[1],
-				m_worldInfo->m_dispatcher);
-		}
-	}
-	else
-	{
+			if(0!=getBroadphaseHandle())
+			{					
+				m_worldInfo->m_broadphase->setAabb(	getBroadphaseHandle(),
+													m_bounds[0],
+													m_bounds[1],
+													m_worldInfo->m_dispatcher);
+			}
+		}
+		else
+		{
 		m_bounds[0]=
-			m_bounds[1]=btVector3(0,0,0);
-	}		
+		m_bounds[1]=btVector3(0,0,0);
+		}		
 }
 
@@ -1826,10 +1813,10 @@
 		pose.m_scl=pose.m_aqq*r.transpose()*Apq;
 		if(m_cfg.maxvolume>1)
-		{
+			{
 			const btScalar	idet=Clamp<btScalar>(	1/pose.m_scl.determinant(),
-				1,m_cfg.maxvolume);
+													1,m_cfg.maxvolume);
 			pose.m_scl=Mul(pose.m_scl,idet);
-		}
-
+			}
+		
 	}
 }
@@ -1886,102 +1873,102 @@
 	int i;
 
-	for( i=0;i<m_clusters.size();++i)
-	{
-		Cluster&	c=*m_clusters[i];
-		c.m_imass=0;
-		c.m_masses.resize(c.m_nodes.size());
-		for(int j=0;j<c.m_nodes.size();++j)
-		{
-			c.m_masses[j]	=	c.m_nodes[j]->m_im>0?1/c.m_nodes[j]->m_im:0;
-			c.m_imass		+=	c.m_masses[j];
-		}
-		c.m_imass		=	1/c.m_imass;
-		c.m_com			=	btSoftBody::clusterCom(&c);
-		c.m_lv			=	btVector3(0,0,0);
-		c.m_av			=	btVector3(0,0,0);
-		c.m_leaf		=	0;
-		/* Inertia	*/ 
-		btMatrix3x3&	ii=c.m_locii;
-		ii[0]=ii[1]=ii[2]=btVector3(0,0,0);
-		{
-			int i,ni;
-
-			for(i=0,ni=c.m_nodes.size();i<ni;++i)
-			{
-				const btVector3	k=c.m_nodes[i]->m_x-c.m_com;
-				const btVector3	q=k*k;
-				const btScalar	m=c.m_masses[i];
-				ii[0][0]	+=	m*(q[1]+q[2]);
-				ii[1][1]	+=	m*(q[0]+q[2]);
-				ii[2][2]	+=	m*(q[0]+q[1]);
-				ii[0][1]	-=	m*k[0]*k[1];
-				ii[0][2]	-=	m*k[0]*k[2];
-				ii[1][2]	-=	m*k[1]*k[2];
-			}
-		}
-		ii[1][0]=ii[0][1];
-		ii[2][0]=ii[0][2];
-		ii[2][1]=ii[1][2];
-		ii=ii.inverse();
-		/* Frame	*/ 
-		c.m_framexform.setIdentity();
+for( i=0;i<m_clusters.size();++i)
+	{
+	Cluster&	c=*m_clusters[i];
+	c.m_imass=0;
+	c.m_masses.resize(c.m_nodes.size());
+	for(int j=0;j<c.m_nodes.size();++j)
+		{
+		c.m_masses[j]	=	c.m_nodes[j]->m_im>0?1/c.m_nodes[j]->m_im:0;
+		c.m_imass		+=	c.m_masses[j];
+		}
+	c.m_imass		=	1/c.m_imass;
+	c.m_com			=	btSoftBody::clusterCom(&c);
+	c.m_lv			=	btVector3(0,0,0);
+	c.m_av			=	btVector3(0,0,0);
+	c.m_leaf		=	0;
+	/* Inertia	*/ 
+	btMatrix3x3&	ii=c.m_locii;
+	ii[0]=ii[1]=ii[2]=btVector3(0,0,0);
+	{
+		int i,ni;
+
+		for(i=0,ni=c.m_nodes.size();i<ni;++i)
+		{
+			const btVector3	k=c.m_nodes[i]->m_x-c.m_com;
+			const btVector3	q=k*k;
+			const btScalar	m=c.m_masses[i];
+			ii[0][0]	+=	m*(q[1]+q[2]);
+			ii[1][1]	+=	m*(q[0]+q[2]);
+			ii[2][2]	+=	m*(q[0]+q[1]);
+			ii[0][1]	-=	m*k[0]*k[1];
+			ii[0][2]	-=	m*k[0]*k[2];
+			ii[1][2]	-=	m*k[1]*k[2];
+		}
+	}
+	ii[1][0]=ii[0][1];
+	ii[2][0]=ii[0][2];
+	ii[2][1]=ii[1][2];
+	ii=ii.inverse();
+	/* Frame	*/ 
+	c.m_framexform.setIdentity();
+	c.m_framexform.setOrigin(c.m_com);
+	c.m_framerefs.resize(c.m_nodes.size());
+	{
+		int i;
+		for(i=0;i<c.m_framerefs.size();++i)
+			{
+			c.m_framerefs[i]=c.m_nodes[i]->m_x-c.m_com;
+			}
+		}
+	}
+}
+
+//
+void					btSoftBody::updateClusters()
+{
+BT_PROFILE("UpdateClusters");
+int i;
+
+for(i=0;i<m_clusters.size();++i)
+	{
+	btSoftBody::Cluster&	c=*m_clusters[i];
+	const int				n=c.m_nodes.size();
+	const btScalar			invn=1/(btScalar)n;
+	if(n)
+		{
+		/* Frame				*/ 
+		const btScalar	eps=btScalar(0.0001);
+		btMatrix3x3		m,r,s;
+		m[0]=m[1]=m[2]=btVector3(0,0,0);
+		m[0][0]=eps*1;
+		m[1][1]=eps*2;
+		m[2][2]=eps*3;
+		c.m_com=clusterCom(&c);
+		for(int i=0;i<c.m_nodes.size();++i)
+			{
+			const btVector3		a=c.m_nodes[i]->m_x-c.m_com;
+			const btVector3&	b=c.m_framerefs[i];
+			m[0]+=a[0]*b;m[1]+=a[1]*b;m[2]+=a[2]*b;
+			}
+		PolarDecompose(m,r,s);
 		c.m_framexform.setOrigin(c.m_com);
-		c.m_framerefs.resize(c.m_nodes.size());
-		{
-			int i;
-			for(i=0;i<c.m_framerefs.size();++i)
-			{
-				c.m_framerefs[i]=c.m_nodes[i]->m_x-c.m_com;
-			}
-		}
-	}
-}
-
-//
-void					btSoftBody::updateClusters()
-{
-	BT_PROFILE("UpdateClusters");
-	int i;
-
-	for(i=0;i<m_clusters.size();++i)
-	{
-		btSoftBody::Cluster&	c=*m_clusters[i];
-		const int				n=c.m_nodes.size();
-		const btScalar			invn=1/(btScalar)n;
-		if(n)
-		{
-			/* Frame				*/ 
-			const btScalar	eps=btScalar(0.0001);
-			btMatrix3x3		m,r,s;
-			m[0]=m[1]=m[2]=btVector3(0,0,0);
-			m[0][0]=eps*1;
-			m[1][1]=eps*2;
-			m[2][2]=eps*3;
-			c.m_com=clusterCom(&c);
-			for(int i=0;i<c.m_nodes.size();++i)
-			{
-				const btVector3		a=c.m_nodes[i]->m_x-c.m_com;
-				const btVector3&	b=c.m_framerefs[i];
-				m[0]+=a[0]*b;m[1]+=a[1]*b;m[2]+=a[2]*b;
-			}
-			PolarDecompose(m,r,s);
-			c.m_framexform.setOrigin(c.m_com);
-			c.m_framexform.setBasis(r);		
-			/* Inertia			*/ 
-#if 1/* Constant	*/ 
-			c.m_invwi=c.m_framexform.getBasis()*c.m_locii*c.m_framexform.getBasis().transpose();
-#else
-#if 0/* Sphere	*/ 
+		c.m_framexform.setBasis(r);		
+		/* Inertia			*/ 
+		#if 1/* Constant	*/ 
+		c.m_invwi=c.m_framexform.getBasis()*c.m_locii*c.m_framexform.getBasis().transpose();
+		#else
+			#if 0/* Sphere	*/ 
 			const btScalar	rk=(2*c.m_extents.length2())/(5*c.m_imass);
 			const btVector3	inertia(rk,rk,rk);
 			const btVector3	iin(btFabs(inertia[0])>SIMD_EPSILON?1/inertia[0]:0,
-				btFabs(inertia[1])>SIMD_EPSILON?1/inertia[1]:0,
-				btFabs(inertia[2])>SIMD_EPSILON?1/inertia[2]:0);
-
+								btFabs(inertia[1])>SIMD_EPSILON?1/inertia[1]:0,
+								btFabs(inertia[2])>SIMD_EPSILON?1/inertia[2]:0);
+			
 			c.m_invwi=c.m_xform.getBasis().scaled(iin)*c.m_xform.getBasis().transpose();
-#else/* Actual	*/ 		
+			#else/* Actual	*/ 		
 			c.m_invwi[0]=c.m_invwi[1]=c.m_invwi[2]=btVector3(0,0,0);
 			for(int i=0;i<n;++i)
-			{
+				{
 				const btVector3	k=c.m_nodes[i]->m_x-c.m_com;
 				const btVector3		q=k*k;
